package labss.lang.il.model.impl;

import labss.lang.il.model.Expression;
import labss.lang.il.model.Statement;


public abstract class ConditionalStatement implements Statement {

	/** 
	 * @uml.property name="condition"
	 * @uml.associationEnd aggregation="composite" inverse="conditionalStatement:labss.lang.il.model.Expression"
	 */
	private Expression condition;

	/** 
	 * Getter of the property <tt>condition</tt>
	 * @return  Returns the condition.
	 * @uml.property  name="condition"
	 */
	public Expression getCondition() {
		return condition;
	}

	/** 
	 * Setter of the property <tt>condition</tt>
	 * @param condition  The condition to set.
	 * @uml.property  name="condition"
	 */
	public void setCondition(Expression condition) {
		this.condition = condition;
	}

	/** 
	 * @uml.property name="trueBody"
	 * @uml.associationEnd aggregation="composite" inverse="conditionalStatement:labss.lang.il.model.Statement"
	 */
	private Statement trueBody;

	/** 
	 * Getter of the property <tt>trueBody</tt>
	 * @return  Returns the trueBody.
	 * @uml.property  name="trueBody"
	 */
	public Statement getTrueBody() {
		return trueBody;
	}

	/** 
	 * Setter of the property <tt>trueBody</tt>
	 * @param trueBody  The trueBody to set.
	 * @uml.property  name="trueBody"
	 */
	public void setTrueBody(Statement trueBody) {
		this.trueBody = trueBody;
	}

	protected ConditionalStatement() {}
	protected ConditionalStatement(Expression condition, Statement trueBody) {
		this.condition = condition;
		this.trueBody = trueBody;
	}

}
