package labss.lang.il.model.impl;

import labss.lang.il.model.*;

public class ILStaticFactory {
    public static Statement createWhile(Expression exp, Statement stm) {
    	return new While(exp, stm);
    }
    public static Statement createIf(Expression exp, Statement thenStm) {
    	return createIf(exp, thenStm, createEmpty());
    }
    public static Statement createIf(Expression exp, Statement thenStm, Statement elseStm) {
    	If ifStm = new If();
    	ifStm.setCondition(exp);
    	ifStm.setTrueBody(thenStm);
    	ifStm.setFalseBody(elseStm);
    	return ifStm;
    }
    public static Statement createEmpty() {
    	return new Empty();
    }
    public static Statement createAssignment(String var, Expression exp) {
    	return new Assignment((Variable) createVariable(var), exp);
    }
    public static Statement createBlock(Statement... stms) {
    	return new Block(stms);
    }
    public static Literal createBoolean(boolean val) {
    	return Bool.instance(val);
    }
    public static Literal createInt(int val) {
    	return new Int(val);
    }
    public static Expression createVariable(String name) {
    	return new Variable(name);
    }
    public static Expression createAddition(Expression exp1, Expression exp2) {
    	return new Addition(exp1, exp2);
    }
    public static Expression createSubtraction(Expression exp1, Expression exp2) {
    	return new Subtraction(exp1, exp2);
    }
    public static Expression createMultiplication(Expression exp1, Expression exp2) {
    	return new Multiplication(exp1, exp2);
    }
    public static Expression createDivision(Expression exp1, Expression exp2) {
    	return new Division(exp1, exp2);
    }
    public static Expression createAnd(Expression exp1, Expression exp2) {
    	return new And(exp1, exp2);
    }
    public static Expression createOr(Expression exp1, Expression exp2) {
    	return new Or(exp1, exp2);
    }
    public static Expression createNot(Expression exp) {
    	return new Not(exp);
    }
    public static Expression createEquals(Expression exp1, Expression exp2) {
    	return new Equals(exp1, exp2);
    }
    public static Expression createLessThan(Expression exp1, Expression exp2) {
    	return new LessThan(exp1, exp2);
    }
    public static Expression createGreaterThan(Expression exp1, Expression exp2) {
    	return new GreaterThan(exp1, exp2);
    }

//TODO esercizio: con questa implementazione costruisco ancora un albero? 
    public static Expression createGreaterOrEquals(Expression exp1, Expression exp2) {
    	return createOr(createGreaterThan(exp1, exp2), createEquals(exp1, exp2));
    }
}
